#include <avr/io.h>        
#include <avr/interrupt.h>
#include <util/delay.h>

void AVR_init(void);
void spi_send(uint8_t);


int main(void)
{
	AVR_init();
	
	while(1)
	{
		
		
	}
	
	return 1;
}

void AVR_init(void)
{
	
// Config the Ports: 
	DDRC = 0xFF; //PORTB: Output (Binary Counter)
	DDRD &= ~(1<<PD2);
	PORTD |= (1<<PD2); //IR-Input.

//Timer1: 
	TCCR1B |= (1<<WGM12); //CTC Mode (OCR1A)
	TCCR1B |= ((1<<CS10) | (1<<CS12)); // Prescaler: 1024
	OCR1A = 20; 
	TIMSK |= (1<<OCIE1A); //Enable the compare-Interrupt
	
//SPI:
	DDRB |= ((1<<PB5) | (1<<PB7) | (1<<PB4)); //MOSI / SCK /SS: Output
	SPCR |= ((1<<SPE) | (1<<MSTR));
	SPSR |= (1<<SPI2X); //8MHz SPI Clock
	
//INT0 (IR):
	MCUCR |= (1<<ISC01); //Int on falling INT0-Edge. 
	GICR |= (1<<INT0); //enable the Interrupt
	
	SREG |= (1<<7); //enable interrupts globally.
}


void spi_send(uint8_t data)
{
	PORTB &= ~(1<<PB4);
	SPDR = data;
	while(!(SPSR & (1<<SPIF))){}
	PORTB |= (1<<PB4);
}



ISR(TIMER1_COMPA_vect)
{
	PORTC++; //let the binary counter count up. 
}

ISR(INT0_vect)
{
	spi_send(PINC); //Send the counter-value to the SPI.
}

