/**************************************************************************************************************
--*
--*   B i t H o u n d   -   A n   F P G A   B a s e d   L o g i c   A n a l y z e r
--*
--*   Firmware 
--* 
--* Copyright 2010-2011   Mario Mauerer (MM), Lukas Schrittwieser (LS), ETH Zurich
--*
--*    This program is free software: you can redistribute it and/or modify
--*    it under the terms of the GNU General Public License as published by
--*    the Free Software Foundation, either version 3 of the License, or
--*    (at your option) any later version.
--*
--*    This program is distributed in the hope that it will be useful,
--*    but WITHOUT ANY WARRANTY; without even the implied warranty of
--*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--*    GNU General Public License for more details.
--*
--*    You should have received a copy of the GNU General Public License
--*    along with this program.  If not, see <http://www.gnu.org/licenses/>.
--*
--***************************************************************************************************************
--*
--* Change Log:
--*
--* Version 1.0 - 2011/08/17 - LS
--*   first release
--*
--*
--***************************************************************************************************************
--*
--* This is file implements functions to control the uart. It buffers the output data and allows the usage of 
--* libc output functions like printf and printf_P (for strings in program space).
--*
--***************************************************************************************************************/

#ifndef __UART_H__
#define __UART_H__

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <stdio.h>


void initUart(void);
int uartPutcStream(char c, FILE * stream);
void uartPutc(char c);
void uartFlush();
//void uartPrintStr(const char *s);
//void uartPrintStr_P(const char *s);

//void printHex (uint8_t i);
//void printMac(uint8_t *b);
//void printHex32 (uint32_t i);
char uartGetc();
//void uartPrintUInt16 (uint16_t i);
//void uartPrintUInt8 (uint8_t i);


// redirect the output function for stdout, this allows us to use printf 
static FILE mystdout = FDEV_SETUP_STREAM( uartPutcStream, NULL, _FDEV_SETUP_WRITE );


#endif
/* end of file */
