--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   19:55:02 11/01/2010
-- Design Name:   
-- Module Name:   D:/e-/logic-analyzer/avr_core/xst/Wb8Wb32Bridge_tb.vhd
-- Project Name:  avrSoC
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: Wb8Wb32Bridge
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY Wb8Wb32Bridge_tb IS
END Wb8Wb32Bridge_tb;
 
ARCHITECTURE behavior OF Wb8Wb32Bridge_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT Wb8Wb32Bridge
    PORT(
         ClkxCI : IN  std_logic;
         RstxRI : IN  std_logic;
         Wb8CycxSI : IN  std_logic;
         Wb8StbxSI : IN  std_logic;
         Wb8WexSI : IN  std_logic;
         Wb8AdrxDI : IN  std_logic_vector(15 downto 0);
         Wb8DatxDI : IN  std_logic_vector(7 downto 0);
         Wb8DatxDO : OUT  std_logic_vector(7 downto 0);
         Wb8AckxSO : OUT  std_logic;
         Wb8ErrxSO : OUT  std_logic;
         Wb32CycxSO : OUT  std_logic;
         Wb32StbxSO : OUT  std_logic;
         Wb32WexSO : OUT  std_logic;
         Wb32SelxSO : OUT  std_logic_vector(3 downto 0);
         Wb32AdrxDO : OUT  std_logic_vector(15 downto 0);
         Wb32DatxDI : IN  std_logic_vector(31 downto 0);
         Wb32DatxDO : OUT  std_logic_vector(31 downto 0);
         Wb32AckxSI : IN  std_logic;
         Wb32ErrxSI : IN  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal ClkxCI : std_logic := '0';
   signal RstxRI : std_logic := '1';
   signal Wb8CycxSI : std_logic := '0';
   signal Wb8StbxSI : std_logic := '0';
   signal Wb8WexSI : std_logic := '0';
   signal Wb8AdrxDI : std_logic_vector(15 downto 0) := (others => '0');
   signal Wb8DatxDI : std_logic_vector(7 downto 0) := (others => '0');
   signal Wb32DatxDI : std_logic_vector(31 downto 0) := (others => '0');
   signal Wb32AckxSI : std_logic := '0';
   signal Wb32ErrxSI : std_logic := '0';

 	--Outputs
   signal Wb8DatxDO : std_logic_vector(7 downto 0);
   signal Wb8AckxSO : std_logic;
   signal Wb8ErrxSO : std_logic;
   signal Wb32CycxSO : std_logic;
   signal Wb32StbxSO : std_logic;
   signal Wb32WexSO : std_logic;
   signal Wb32SelxSO : std_logic_vector(3 downto 0);
   signal Wb32AdrxDO : std_logic_vector(15 downto 0);
   signal Wb32DatxDO : std_logic_vector(31 downto 0);

   -- Clock period definitions
   constant ClkxCI_period : time := 25 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: Wb8Wb32Bridge PORT MAP (
          ClkxCI => ClkxCI,
          RstxRI => RstxRI,
          Wb8CycxSI => Wb8CycxSI,
          Wb8StbxSI => Wb8StbxSI,
          Wb8WexSI => Wb8WexSI,
          Wb8AdrxDI => Wb8AdrxDI,
          Wb8DatxDI => Wb8DatxDI,
          Wb8DatxDO => Wb8DatxDO,
          Wb8AckxSO => Wb8AckxSO,
          Wb8ErrxSO => Wb8ErrxSO,
          Wb32CycxSO => Wb32CycxSO,
          Wb32StbxSO => Wb32StbxSO,
          Wb32WexSO => Wb32WexSO,
          Wb32SelxSO => Wb32SelxSO,
          Wb32AdrxDO => Wb32AdrxDO,
          Wb32DatxDI => Wb32DatxDI,
          Wb32DatxDO => Wb32DatxDO,
          Wb32AckxSI => Wb32AckxSI,
          Wb32ErrxSI => Wb32ErrxSI
        );

   -- Clock process definitions
   ClkxCI_process :process
   begin
		ClkxCI <= '0';
		wait for ClkxCI_period/2;
		ClkxCI <= '1';
		wait for ClkxCI_period/2;
   end process;
 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100 ns.
      wait for 100 ns;	
	  RstxRI <= '0';
	  wait for ClkxCI_period*10;
	  
	  -- generate 4 write accesses
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"5678";
	  Wb8DatxDI		<= x"0A";
	  Wb8WexSI		<= '1';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"5679";
	  Wb8DatxDI		<= x"BC";
	  Wb8WexSI		<= '1';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"567A";
	  Wb8DatxDI		<= x"DE";
	  Wb8WexSI		<= '1';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"567B";
	  Wb8DatxDI		<= x"F0";
	  Wb8WexSI		<= '1';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  -- generate 4 read accesses
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"5678";
	  Wb8DatxDI		<= x"00";
	  Wb8WexSI		<= '0';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"5679";
	  Wb8DatxDI		<= x"00";
	  Wb8WexSI		<= '0';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"567A";
	  Wb8DatxDI		<= x"00";
	  Wb8WexSI		<= '0';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  wait until ClkxCI'event and ClkxCI='1';
	  Wb8AdrxDI		<= x"567B";
	  Wb8DatxDI		<= x"00";
	  Wb8WexSI		<= '0';
	  Wb8CycxSI		<= '1';
	  Wb8StbxSI		<= '1';
	  wait until ClkxCI'event and ClkxCI='1' and (Wb8AckxSO='1' or Wb8ErrxSO='1');
	  Wb8CycxSI		<= '0';	
	  Wb8StbxSI		<= '0';
	  
	  
      wait;
   end process;


	-- generate an ack on wb32 for every access
	Wb32AckxSI	<= Wb32CycxSO and Wb32StbxSO;
	
	-- simply copy data on wb32 bus
	process (ClkxCI, Wb32AckxSI, Wb32DatxDO)
	begin
		if ClkxCI'event and ClkxCI='1' and Wb32AckxSI='1' then
			Wb32DatxDI <= Wb32DatxDO;
		end if;
	end process;

END;
